// BombMaster
// code by jph

import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;
import sun.audio.*;

public class BombMaster
{
  static final String WEBHOST="http://users.tkk.fi/~jhakenbe/spacebomber/";  
  static final int RELEASE=103;   
  static final int BROADCAST=512;  
  static final int PERIOD=75;
  static final int HEADER=2;
  static final int CHUNK=6;  
  
  static String IQ="82.130.15.70";  // a priori list of server IPs
  static String IP;                   //          server IP
  static int TC=49408;                // a priori server TCP port
  static int UD;                      //          server UDP port
  static Worldmap[] myWorldmap;

  // obtain from webhost:
  //  server IP and TC port
  //  worldmaps  
  public static void config() { // BombMaster, SpaceBomber
    System.out.println("release "+RELEASE);
    try {
      URL myURL=new URL(WEBHOST+RELEASE+".config.txt");
      URLConnection myURLConnection=myURL.openConnection();
      myURLConnection.setDoInput(true);
      myURLConnection.setUseCaches(false);
      DataInputStream myDataInputStream=new DataInputStream(myURLConnection.getInputStream());
      IQ=myDataInputStream.readLine();
      TC=Integer.parseInt(myDataInputStream.readLine());
      String myString=myDataInputStream.readLine();
      String[] mySplit=myString.split(" ");
      myWorldmap=new Worldmap[mySplit.length];
      for (int c1=0;c1<mySplit.length;c1++) {
        myWorldmap[c1]=new Worldmap(WEBHOST+RELEASE+"."+mySplit[c1]+".txt");        
        System.out.println("map "+c1+" "+mySplit[c1]+" "+myWorldmap[c1].playa_min+" to "+myWorldmap[c1].playa_max);
      }
      myDataInputStream.close();
      myDatagramSocket=new DatagramSocket();  	  
    } catch (Exception myException) {
      System.out.println("Configuration "+myException);
    }
  }
  
  static DatagramSocket myDatagramSocket;
  static Hashtable myHashtable=new Hashtable(); // key ident, value AniBomber
  static int ident=-1;                      // each client gets unique ident
  static int map=-1;                        // index of map
  static int cwd=0;                         // timer to change level, change with dignity
  
  // initializes thread
	static public void main(String[] args) {  // BombMaster
  	try {    	
    	config();
  	  map=Animated.myRandom.nextInt(myWorldmap.length);           // start with random map
  	  
      new java.util.Timer().scheduleAtFixedRate(
        new TimerTask() {
          public void run() {
            Iterator myIterator;
            int count=myHashtable.size();
            if (cwd<=Animated.utc||count<myWorldmap[map].playa_min||myWorldmap[map].playa_max<count) {              
              do {
                map++;
                map%=myWorldmap.length;
              } while (count<myWorldmap[map].playa_min||myWorldmap[map].playa_max<count);                            
              cwd=Animated.utc+myWorldmap[map].minutes*60000/PERIOD;
              System.out.println(Animated.utc+" set worldmap "+map+" until "+cwd);
              Animated.myLinkedList.clear();
              Animated.myWorldmap=myWorldmap[map];              
              Animated.myWorldmap.GottesWerk();              
              myIterator=myHashtable.values().iterator();
              while (myIterator.hasNext()) {
                AniBomber myAniBomber=(AniBomber)myIterator.next();
                myAniBomber.newInLevel();
              }
            }            
            myIterator=myHashtable.values().iterator();
            while (myIterator.hasNext()) {                        // add bombers to level
              AniBomber myAniBomber=(AniBomber)myIterator.next();
              if (Animated.utc<myAniBomber.clock)
                Animated.myLinkedList.add(myAniBomber);           // else remove !?
            }
            Animated.myWorldmap.TeufelsBeitrag();
            Animated.sims();
            byte[] myByte=new byte[BombMaster.BROADCAST];
            myByte[0]=(byte)BombMaster.map;
            Animated.castAll(myByte,BombMaster.HEADER);
            Animated.free();
            DatagramPacket myDatagramPacket;
            try {                                                 // broadcast
              myIterator=myHashtable.values().iterator();
              while (myIterator.hasNext()) {
                AniBomber myAniBomber=(AniBomber)myIterator.next();              
                myByte[1]=(byte)(myAniBomber.type&SpaceBomber.MASK_TYPE);
                if (myAniBomber.ready<Animated.utc)
                  myByte[1]+=SpaceBomber.MASK_REDY;
                myDatagramPacket=new DatagramPacket(myByte,0,BROADCAST,InetAddress.getByName(myAniBomber.IP),myAniBomber.UD);
                myDatagramSocket.send(myDatagramPacket);
                if (myAniBomber.clock<Animated.utc) {             // lost connection to client
                  System.out.println("   good bye "+myAniBomber.IP+":"+myAniBomber.UD);
                  myIterator.remove();
                }
              }
            } catch (Exception myException) {
              System.out.println(myException);
            }
          }
        },0,PERIOD);
        
      new Thread() {
        public void run() {
          try {
            DatagramPacket myDatagramPacket=new DatagramPacket(new byte[SpaceBomber.DOWNLINK],SpaceBomber.DOWNLINK);
            AniBomber myAniBomber;
            int lo,hi,ident;
            while (true) {
              myDatagramSocket.receive(myDatagramPacket);
              byte[] myByte=myDatagramPacket.getData();
              lo=myByte[0]; if (lo<0) lo+=256;
              hi=myByte[1]; if (hi<0) hi+=256;
              if (myHashtable.containsKey(new Integer(hi*256+lo)))
                ((AniBomber)myHashtable.get(new Integer(hi*256+lo))).inject(myByte);
            }
          } catch (Exception myException) {
            System.out.println("DatagramPacket "+myException);
          }
        }
      }.start();

      ServerSocket myServerSocket=new ServerSocket(TC);
      AniBomber myAniBomber;
      while (true) {
        Socket mySocket=myServerSocket.accept();        
        DataInputStream myDataInputStream=new DataInputStream(mySocket.getInputStream());
        DataOutputStream myDataOutputStream=new DataOutputStream(mySocket.getOutputStream());
        ident++;
        myAniBomber=new AniBomber(mySocket.getInetAddress().getHostAddress(),myDataInputStream.readInt());
        myHashtable.put(new Integer(ident),myAniBomber);
        myDataOutputStream.writeInt(RELEASE);
        myDataOutputStream.writeInt(myDatagramSocket.getLocalPort());
        myDataOutputStream.writeInt(ident);
        myDataOutputStream.flush();
        myDataInputStream.close();
        myDataOutputStream.close();
        mySocket.close();
        AudioStream myAudioStream=new AudioStream(new FileInputStream("res/gong.wav"));
        AudioPlayer.player.start(myAudioStream);
      }
    } catch (Exception myException) {
      System.out.println("ServerSocket "+myException);
      System.exit(0);
    }
  }

  // locate a running server from the list
  // notify the server of client
  public static void register() { // SpaceBomber
    StringTokenizer myStringTokenizer=new StringTokenizer(IQ," ");
    while (myStringTokenizer.hasMoreTokens())
      try {
        IP=myStringTokenizer.nextToken();
        System.out.print("BombMaster "+IP+":"+TC+" ");
        Socket mySocket=new Socket(InetAddress.getByName(IP),TC);
        DataOutputStream myDataOutputStream=new DataOutputStream(mySocket.getOutputStream());
        myDataOutputStream.writeInt(myDatagramSocket.getLocalPort());
        myDataOutputStream.flush();
        DataInputStream myDataInputStream=new DataInputStream(mySocket.getInputStream());      
        if (myDataInputStream.readInt()!=RELEASE) {
          System.out.println("please obtain the new RELEASE from\n"+WEBHOST);
          System.exit(0);
        }
        UD=myDataInputStream.readInt();
        ident=myDataInputStream.readInt();
        myDataOutputStream.close();
        myDataInputStream.close();
        mySocket.close();
        System.out.println(UD+" ["+BombMaster.ident+"]");
        return;
      } catch (Exception myException) {
        System.out.println(myException);        
      }
    System.exit(0);
  }
}
