//code by jph

import java.awt.*;
import javax.swing.*;

public class Animation
{
  JComponent myJComponent;
  Image myImage;
  int seg_x,seg_y;
  int dim_x,dim_y;
  int numel=1;
    
	public Animation(JComponent myJComponent,String myString,int width,int height,int seg_x,int seg_y) {  	
  	this.myJComponent=myJComponent;
  	myImage=myJComponent.getToolkit().getImage(myString);
  	this.seg_x=seg_x;
  	this.seg_y=seg_y;
  	dim_x=width /seg_x;
  	dim_y=height/seg_y;
  	numel=seg_x*seg_y;
	}
	
	void plot(Graphics myGraphics,int frame,int pos_x,int pos_y) {
  	int ofs_x=( frame       %seg_x)*dim_x;
  	int ofs_y=((frame/seg_x)%seg_y)*dim_y;
  	myGraphics.drawImage(myImage,
  	  pos_x-dim_x/2,pos_y-dim_y/2,pos_x+dim_x-dim_x/2,pos_y+dim_y-dim_y/2,
  	  ofs_x,ofs_y,ofs_x+dim_x,ofs_y+dim_y,
  	  myJComponent);
	}
}
